import java.lang.*;
import java.io.*;


interface SendableRunnable extends Runnable
    {
    public void requestPause(int mills);
    }

final class ThreadPauseKludge implements Externalizable
    {
    SendableThread st;
    Thread t;
    public ThreadPauseKludge(SendableThread n_st)
        {
        st=n_st;
        t=new Thread(st);
        }
    public void writeExternal(ObjectOutput out) throws IOException
        {
        System.out.println("Calling writeExternal on ThreadPauseKludge object");
        st.requestPause(0);
        out.writeObject(st);
        }
    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException
        {
        System.out.println("Calling readExternal on ThreadPauseKludge object");
        st=(SendableThread)in.readObject();
        t=new Thread(st);
        st.start();
        }
    public Thread getCurrentThread()
        {
        return t;
        }
    }

public abstract class SendableThread implements SendableRunnable,Serializable
    {
    ThreadPauseKludge k;
    public SendableThread()
        {
        k=new ThreadPauseKludge(this);
        }
    public abstract void requestPause(int mills);
    public void start()
        {
        k.getCurrentThread().start();
        }
    public void stop()
        {
        k.getCurrentThread().stop();
        }

    }
