import java.lang.*;
import java.io.*;
import magicsend.*;

//This program must be run as
//      java TestClassLoader Reciever <args>


public class TestThreadReader
    {
    public static void main(String args[])
        {
        try
            {
            System.out.println("OK, unpacking object from a file.");

                //Open the files
            ObjectInputStream objInput=new ClassAndObjectInputStream(new FileInputStream("test_object.objects"),new FileInputStream("test_object.classes"));

                //Load the object from the Streams
            Object o=objInput.readObject();
            objInput.close();

                //Display something about the object to prove it works
            try { Thread.sleep(5000); } catch (Exception e) {System.out.println("Sleep Interrupted"+e.toString());}
            }
        catch (IOException e) {System.out.println("IO error while saving data");}
        catch (ClassNotFoundException e)    {System.out.println("Failed to unpack object because the JavaVM failed to load its class");return;};
        }
    }
